-- name: [CS] Mott model
-- description: [CS] Mott model by GeloxNG.
-- deluxe: true

if SM64COOPDX_VERSION == nil then
    local first = false
    hook_event(HOOK_ON_LEVEL_INIT, function()
        if not first then
            first = true
            play_sound(SOUND_MENU_CAMERA_BUZZ, gMarioStates[0].marioObj.header.gfx.cameraToObject)
            djui_chat_message_create("\\#ffa0a0\\Mott Model is not supported with sm64ex-coop\nas it uses sm64coopdx exclusive Lua functionality.\n\\#dcdcdc\\To play this mod, try out sm64coopdx at\n\\#7f7fff\\https://sm64coopdx.com")
        end
    end)
    return
end
if not _G.charSelectExists then
    local first = false
    hook_event(HOOK_ON_LEVEL_INIT, function()
        if not first then
            first = true
            play_sound(SOUND_MENU_CAMERA_BUZZ, gGlobalSoundSource)
            djui_chat_message_create("\\#ffffa0\\Mott model requires Character Select to be enabled.\nPlease rehost with it enabled.")
        end
    end)
    return
end

local E_MODEL_MOTT = smlua_model_util_get_id("mott_geo")

local TEX_MOTT = get_texture_info("mott_icon")

local capMott = {
    normal = smlua_model_util_get_id("mott_cap_geo"),
    wing = smlua_model_util_get_id("mott_wing_cap_geo"),
    metal = smlua_model_util_get_id("mott_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("mott_winged_metal_cap_geo")
}

local VOICETABLE_MOTT = {
    [CHAR_SOUND_ATTACKED] = "mott_hurt_hard.ogg",
    [CHAR_SOUND_GROUND_POUND_WAH] = "mott_wah.ogg",
    [CHAR_SOUND_HAHA] = "mott_haahaa.ogg",
    [CHAR_SOUND_HAHA_2] = "mott_haahaa.ogg",
    [CHAR_SOUND_HERE_WE_GO] = "mott_here_we_go.ogg",
    [CHAR_SOUND_HOOHOO] = "mott_jump.ogg",
    [CHAR_SOUND_ON_FIRE] = "mott_burning.ogg",
    [CHAR_SOUND_OOOF] = "mott_oof.ogg",
    [CHAR_SOUND_OOOF2] = "mott_oof_2.ogg",
    [CHAR_SOUND_PUNCH_HOO] = "mott_hoo.ogg",
    [CHAR_SOUND_PUNCH_WAH] = "mott_wah.ogg",
    [CHAR_SOUND_PUNCH_YAH] = "mott_yah.ogg",
    [CHAR_SOUND_SO_LONGA_BOWSER] = "mott_bowser.ogg",
    [CHAR_SOUND_TWIRL_BOUNCE] = "mott_boing.ogg",
    [CHAR_SOUND_WAAAOOOW] = "mott_fall.ogg",
    [CHAR_SOUND_WAH2] = "mott_jump.ogg",
    [CHAR_SOUND_WHOA] = "mott_woah.ogg",
    [CHAR_SOUND_YAHOO] = "mott_yahoo.ogg",
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {"mott_yahoo.ogg", "mott_yippee.ogg"},
    [CHAR_SOUND_YAH_WAH_HOO] = {"mott_yah.ogg", "mott_wah.ogg", "mott_hoo.ogg"},
    [CHAR_SOUND_OKEY_DOKEY] = "mott_okay.ogg",
    [CHAR_SOUND_LETS_A_GO] = "mott_lets_a_go.ogg",
    [CHAR_SOUND_DYING] = "mott_dead.ogg",
    [CHAR_SOUND_DROWNING] = "mott_drowning.ogg",
    [CHAR_SOUND_EEUH] = "mott_eugh.ogg",
    [CHAR_SOUND_MAMA_MIA] = "mott_ooh.ogg",
    [CHAR_SOUND_DOH] = "mott_oof.ogg",
    [CHAR_SOUND_HRMM] = "mott_pickup.ogg",
    [CHAR_SOUND_PANTING] = "mott_pant.ogg",
    [CHAR_SOUND_UH] = "mott_oof.ogg",
    [CHAR_SOUND_IMA_TIRED] = "mott_im_a_tired.ogg",
    [CHAR_SOUND_SNORING1] = "mott_snore.ogg",
    [CHAR_SOUND_SNORING2] = "mott_snore2.ogg",
    [CHAR_SOUND_SNORING3] = {"mott_snore2.ogg", "mott_snore.ogg"},
    [CHAR_SOUND_YAWNING] = "mott_yawn.ogg"
}

_G.charSelect.character_add("Mott", {"", "", ""}, "GeloxNG", { r = 255, g = 132, b = 30 }, E_MODEL_MOTT, CT_TOAD, TEX_MOTT)
_G.charSelect.character_add_voice(E_MODEL_MOTT, VOICETABLE_MOTT)
_G.charSelect.character_add_caps(E_MODEL_MOTT, capMott)

hook_event(HOOK_MARIO_UPDATE, function (m)
    if _G.charSelect.character_get_voice(m) == VOICETABLE_MOTT then _G.charSelect.voice.snore(m) end
end)
hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
    if _G.charSelect.character_get_voice(m) == VOICETABLE_MOTT then return _G.charSelect.voice.sound(m, sound) end
end)